//*************************************************************************************
// 	: SQ7653_TMRA0_PPG.c
// 汾		: V1.0 2020/07/17A
// 		: PPG A0 (TMRA0)_PPGʹú
// ע		: TMRA0_PPG غ㼯ڱӳ
//**************************************************************************************
#include "main.h"

unsigned char TMRA00_Int_Flag;		// TMRA00жϷ
unsigned char TMRA01_Int_Flag;	    // TMRA01жϷ
extern volatile unsigned int TMRA01_Int_count_value = 0;

//*********************************************************************
// 	: TMRA00_8bit_PPG_Init()
// 	: TMRA00 8λɱPPG ģʽʼ
// ע		: TMRA0֮Counter0 (TMRA00)
//*********************************************************************
void TMRA00_8bit_PPG_Init(){
	
//====== ܿ( Enable) ======
	PCKEN0_TMRA0 = 1;					// TMRA0ܿ( Enable)  *ȿݴò
	
//====== 趨 ======

	//1.)---ģʽ趨->
	TMRA0CFG_TCFG = set_8bit;			// TMRA0Ϊ8λģʽ
	TMRA0MD0_TCM  = ppg ;				// Counter0 (TMRA00)ģʽ趨ΪɱPPG

	// /ֹ˫
	TMRA0MD0_DBE = 1;					// 1:  ˫Ĵ
	//TMRA0MD0_DBE = 0;					// 0: ֹ ˫Ĵ

	//2.)---趨Դʱ->				
	//ϵͳƵΪ24MHz,TCA1֮ƵΪ23.437kHz
	TMRA0MD0_TCK = 0x01;				// ʱTMRA00Դʱѡ,A 2^10 (24M/1024=23.437kHz)λʱԼΪ0.0426ms	

	//3.)---ܽųʼ->
	//---ɱPPG ܽ趨(P0.5)TA00O->
    //P0CFGCR֮[bit7]=1(д)[bit6:4]=(λ)[bit3:0]Datasheet֮PNIC½ڲ趨 λ
	P0CFGCR = 0xD1;  				    // P0.5OTA01O	1 101 0001
	
	//4.)---PPGʼƽ趨->
	TMRA0MD0_TFF   = 1;					// ߵƽ
	//TMRA0MD0_TFF = 0;					// ͵ƽ
    
}



//*********************************************************************
// 	: TMRA01_8bit_PPG_Init()
// 	: TMRA01 8λɱPPG ʼ
// ע		: TMRA0֮ Counter1 (TMRA01)
//*********************************************************************
void TMRA01_8bit_PPG_Init(){
	
//====== ܿ( Enable) ======
	PCKEN0_TMRA0 = 1;                   // TMRA0ܿ( Enable)  *ȿݴò

//====== 趨 ======

	//1.)---ģʽ趨->
	TMRA0CFG_TCFG = set_8bit;			// TMRA0Ϊ8λģʽ
	TMRA0MD1_TCM  = ppg ;				// Counter1 (TMRA01)ģʽ趨ΪɱPPG
	
	// /ֹ˫
	TMRA0MD1_DBE = 1;					// 1:  ˫Ĵ
	//TMRA0MD1_DBE = 0;					// 0: ֹ ˫Ĵ	
	
	//2.)---趨Դʱ->
	//ϵͳƵΪ24MHz,TCA1֮ƵΪ23.437kHz
	TMRA0MD1_TCK = 0x01;				// ʱTMRA01Դʱѡ,A 2^10 (24M/1024=23.437kHz)λʱԼΪ0.0426ms	


	//3.)---ܽųʼ->
	//---ɱPPG ܽ趨(P0.4)TA01O->
    //P0CFGCR֮[bit7]=1(д)[bit6:4]=(λ)[bit3:0]Datasheet֮PNIC½ڲ趨 λ
	P0CFGCR = 0xC1;  				    // P0.4OTA01O	1 100 0001
	
	//4.)---PPGʼƽ趨->
	TMRA0MD1_TFF   = 1;					// ߵƽ
	//TMRA0MD1_TFF = 0;					// ͵ƽ


}




//*********************************************************************
// 	: TMRA0_16bit_PPG_Init()
// 	: TMRA0 16λɱPPG ʼ
// ע		: 16bitʱTMRA0 ֮Counter1 (TMRA01)趨
//*********************************************************************
void TMRA0_16bit_PPG_Init(){

//====== ܿ( Enable) ======
	PCKEN0_TMRA0 = 1;                   // TMRA0ܿ( Enable)  *ȿݴò

//====== 趨 ======
	//1.)---ģʽ趨->
	TMRA0CFG_TCFG = set_16bit;			// 趨TMRA0ģʽ
	TMRA0MD1_TCM  = ppg ;				// ģʽ趨ΪɱPPG
	
	// /ֹ˫
	TMRA0MD1_DBE	= 1;				// 1:  ˫Ĵ
	//TMRA0MD1_DBE 	= 0;				// 0: ֹ ˫Ĵ	
	
	//2.)---趨Դʱ->
	//ϵͳƵΪ24MHz,TCA1֮ƵΪ11.718KHz
	TMRA0MD1_TCK = 0x00;				// ʱTMRA01Դʱѡ,A 2^11 (24M/2048=11.718KHz)λʱԼΪ0.08533ms

	//3.)---ܽųʼ->
	//---ɱPPG ܽ趨(P0.4)TA01O->
    //P0CFGCR֮[bit7]=1(д)[bit6:4]=(λ)[bit3:0]Datasheet֮PNIC½ڲ趨 λ
	P0CFGCR = 0xC1;  				    // P0.4OTA01O	1 100 0001
	
	//4.)---PPGʼƽ趨->
	TMRA0MD1_TFF   = 1;					// ߵƽ
	//TMRA0MD1_TFF = 0;					// ͵ƽ
	
	
}



//*********************************************************************
// 	: TMRA00_IntEnable()
// 	: TMRA00ж (Enable)
// ע		:  8λģʽ£TMRA00ʹ
//*********************************************************************
void TMRA00_IntEnable(){
	__ASM("DI");					    // ֹпж
	IER_TMRA00_IRQ = 1;                 // TMRA00 ж

	//---λжϿ->	
	//TMRA0CR0_TMROVIE = 1;             // λʱTMRA00жҪ
	
	__ASM("EI");						// пж
}


//*********************************************************************
// 	: TMRA01_IntEnable()
// 	: TMRA01ж (Enable)
// ע		: 1.  8λģʽ£TMRA01ʹ
//            2. 16λģʽ£TMRA00ص趨ʧЧֻʣTMRA01趨Ч
//               ֻTMRA01ж
//*********************************************************************
void TMRA01_IntEnable(){
	__ASM("DI");					    // ֹпж
	IER_TMRA01_IRQ = 1;                 // TMRA01 ж

	//---λжϿ->	
	//TMRA0CR1_TMROVIE = 1;             // λʱTMRA01жҪ
	
	__ASM("EI");						// пж
}



//*********************************************************************
// 	: TMRA00_IntDisable()
// 	: TMRA00жϽֹ (Disable)
// ע		: 
//*********************************************************************
void TMRA00_IntDisable(){
	__ASM("DI");					    // ֹпж
	IER_TMRA00_IRQ = 0;                 // TMRA00 жϽֹ

	//---λжϿ->
	//TMRA0CR0_TMROVIE = 0;             // λʱTMRA00жҪ
	
	__ASM("EI");						// пж
}


//*********************************************************************
// 	: TMRA01_IntDisable()
// 	: TMRA01жϽֹ (Disable)
// ע		: 
//*********************************************************************
void TMRA01_IntDisable(){
	__ASM("DI");					    // ֹпж
	IER_TMRA01_IRQ = 0;                 // TMRA01 жϽֹ
	
	//---λжϿ->
	//TMRA0CR1_TMROVIE = 0;             // λʱTMRA01жҪ
	
	__ASM("EI");						// пж
}



//*********************************************************************
// 	: TMRA00_SetPeriod()
// 	: 趨TMRA00 ڣѭʱ
// ע		: PPG A0,Counter0
//*********************************************************************
void TMRA00_SetPeriod(unsigned int period){	
	TMRA0DR0 = period;              	// 趨TMRA00

}




//*********************************************************************
// 	: TMRA01_SetPeriod()
// 	: 趨TMRA01 ڣѭʱ
// ע		: PPG A0,Counter1
//*********************************************************************
void TMRA01_SetPeriod(unsigned int period){	
	TMRA0DR1 = period;              	// 趨TMRA01

}



//*********************************************************************
//    : TMRA0_16bit_SetPeriod()
//  : 趨16λTMRA00(8λ)+TMRA01(8λ) ڣѭʱ
// ע     : PPG A0,Counter0 + Counter1
//*********************************************************************
void TMRA0_16bit_SetPeriod(unsigned int period){    
    TMRA0DR0 = period&0xff;             // 趨λ
    TMRA0DR1 = period>>8;               // 趨λ
	
}



//*********************************************************************
// 	: TMRA00_SetDuty()
// 	: 趨TMRA00 ռձ
// ע		: PPG A0,Counter0
//*********************************************************************
void TMRA00_SetDuty(unsigned int duty){	
	TMRA0PWM0 = duty;              		// 趨TMRA00

}




//*********************************************************************
// 	: TMRA01_SetDuty()
// 	: 趨TMRA01 ռձ
// ע		: PPG A0,Counter1
//*********************************************************************
void TMRA01_SetDuty(unsigned int duty){	
	TMRA0PWM1 = duty;              		// 趨TMRA01

}



//*********************************************************************
//    : TMRA0_16bit_SetDuty()
//  : 趨16λTMRA00(8λ)+TMRA01(8λ) ռձ
// ע     : PPG A0,Counter0 + Counter1
//*********************************************************************
void TMRA0_16bit_SetDuty(unsigned int duty){    
    TMRA0PWM0 = duty&0xff;             	// 趨λ
    TMRA0PWM1 = duty>>8;               	// 趨λ
	
}





//*********************************************************************
// 	: TMRA00_Start()
// 	: TMRA00ɱPPG 
// ע		:  8λģʽ£TMRA00ʹ
//*********************************************************************
void TMRA00_Start(){
	TMRA0CR0_RUN = 1;                   // TMRA00ʼPPG 
	
}


//*********************************************************************
// 	: TMRA01_Start()
// 	: TMRA01ɱPPG 
// ע		:  8λģʽ£TMRA01ʹ
//*********************************************************************
void TMRA01_Start(){
	TMRA0CR1_RUN = 1;                   // TMRA01ʼPPG 
	
}


//*********************************************************************
// 	: TMRA0_16bit_Start()
// 	: 16λTMRA00(8λ)+TMRA01(8λ) PPG 
// ע		: 
//*********************************************************************
void TMRA0_16bit_Start(){
	TMRA0CR1_RUN = 1;                   // ʼ16λPPG 
	
}


//*********************************************************************
// 	: TMRA00_Stop()
// 	: ֹͣTMRA00 PPG 
// ע		:  8λģʽ£TMRA00ʹ
//*********************************************************************
void TMRA00_Stop(){
	TMRA0CR0_RUN = 0;                   // ֹͣTMRA00 PPG 
	IFR_TMRA00_IRQ = 0;					// TMRA00_IRQжϱ
}


//*********************************************************************
// 	: TMRA01_Stop()
// 	: ֹͣTMRA01 PPG 
// ע		:  8λģʽ£TMRA01ʹ
//*********************************************************************
void TMRA01_Stop(){
	TMRA0CR1_RUN = 0;                   // ֹͣTMRA01 PPG 
	IFR_TMRA01_IRQ = 0;					// TMRA01_IRQжϱ
}


//*********************************************************************
// 	: TMRA0_16bit_Stop()
// 	: ֹͣ16λTMRA00(8λ)+TMRA01(8λ) PPG 
// ע		: 
//*********************************************************************
void TMRA0_16bit_Stop(){
	TMRA0CR1_RUN = 0;                   // ֹͣ16λPPG 
	IFR_TMRA01_IRQ = 0;					// TMRA01_IRQжϱ
}


//*********************************************************************
// 	: __interrupt TMRA00_IRQ()
// 	: TMRA00жӳ
// ע		:  8λģʽ£TMRA00ʹ
//*********************************************************************
void __interrupt TMRA00_IRQ(void){
	__asm("NOP");						// ָ
	//TMRA00_Int_Flag = 1;				// TMRA00жϷ趨Ϊ1

	
}


//*********************************************************************
// 	: __interrupt TMRA01_IRQ()
// 	: TMRA01жӳ
// ע		: 1.  8λģʽ£TMRA01ʹ
//            2. 16λģʽ£ʹTMRA01жӳ
//*********************************************************************
void __interrupt TMRA01_IRQ(void){
	__asm("NOP");						// ָ

	TMRA01_Int_count_value++;
	IER_TMRA01_IRQ = 0;					// Disable the interrupt

	if(TMRA01_Int_count_value == 2){    // PPG趨Ϊ:ֻ
		TMRA01_Int_Flag = 1;			// TMRA01жϷ趨Ϊ1
		TMRA0_16bit_Stop();				// ֹͣ16λTMRA00(8λ)+TMRA01(8λ) PPG 

	}
	
	IER_TMRA01_IRQ = 1;					// Enable the interrupt
	
}

