//*************************************************************************************
// 	: SQ7653_TMRA4_PulseMeasure.c
// 汾		: V1.0 2020/07/17A
// 		: Timer A3 (TMRA4)_PulseMeasureʹú
// ע		: TMRA4_PulseMeasure غ㼯ڱӳ
//**************************************************************************************
#include "main.h"

unsigned char TMRA40_Int_Flag;		    // TMRA40жϷ
unsigned char TMRA41_Int_Flag;		    // TMRA41жϷ

unsigned int  measure_count;
unsigned int  L_pulse_measure_count;      // ֮L_pulse
unsigned int  H_pulse_measure_count;      // ֮H_pulse
unsigned char Data_L  ,Data_H;			// תȡTMRA4DRx 
unsigned char Data_PWL,Data_PWH;			// תȡTMRA4PWMx

//*********************************************************************
// 	: TMRA40_8bit_PulseMeasure_Init()
// 	: TMRA40_8bit_ģʽʼ
// ע		: TMRA4֮Counter0 (TMRA40)
//*********************************************************************
void TMRA40_8bit_PulseMeasure_Init(){
//====== ܿ( Enable) ======
	PCKEN0_TMRA4 = 1;                   	// TMRA4ܿ( Enable)  *ȿݴò	

//====== 趨 ======

	//1.)---ģʽ趨->
	TMRA4CFG_TCFG = set_8bit;				// TMRA4Ϊ8λģʽ
	TMRA4MD0_TCM  = pulse_measure;    		// TMRA40趨Ϊģʽ
	
    // /ֹ˫
	TMRA4MD0_DBE  = 1;                	    // 1: ʹ˫
    //TMRA4MD0_DBE  = 0;                    // 0: ֹ˫

	//2.)---趨ԴʵʱƵ->
	//ϵͳƵΪ24MHz,
    //TMRA4MD0_TCK = 0x00;				    // ʱTMRA40Դʱѡ,A 2^11 (24M/2048=11.718kHz)λʱԼΪ0.0853ms
    TMRA4MD0_TCK = 0x01;                	// ʱTMRA40Դʱѡ,A 2^10 (24M/1024=23.437kHz)λʱԼΪ0.0426ms (42.6667us)

	//3.)---ܽųʼ->
	//---Ѷ֮ܽ趨(P0.3)TA4G->
    //P0CFGCR֮[bit7]=1(д)[bit6:4]=(λ)[bit3:0]Datasheet֮PNIC½ڲ趨 λ
	P0CFGCR = 0xB4;  						// P0.3OTA4G	1 011 0100

	//4.)---ģʽѶشѡ->
	TMRA4CR0_EDGE = 0x00;					// ص½ (H Pluse)
	//TMRA4CR0_EDGE = 0x01;					// ½ص (L Pluse)
	//TMRA4CR0_EDGE = 0x02;					// ص ()
	//TMRA4CR0_EDGE = 0x03;					// ½ص½ ()
	//TMRA4CR0_EDGE = 0x04;					// H Pluse

}



//*********************************************************************
// 	: TMRA41_8bit_PulseMeasure_Init()
// 	: TMRA41_8bit_ģʽʼ
// ע		: TMRA4֮Counter1 (TMRA41)
//*********************************************************************
void TMRA41_8bit_PulseMeasure_Init(){
//====== ܿ( Enable) ======
	PCKEN0_TMRA4 = 1;                   	// TMRA4ܿ( Enable)  *ȿݴò	

//====== 趨 ======

	//1.)---ģʽ趨->
	TMRA4CFG_TCFG = set_8bit;				// TMRA4Ϊ8λģʽ
	TMRA4MD1_TCM  = pulse_measure;    		// TMRA41趨Ϊģʽ
	
    // /ֹ˫
	TMRA4MD1_DBE  = 1;                	    // 1: ʹ˫
    //TMRA4MD1_DBE  = 0;                    // 0: ֹ˫

	//2.)---趨ԴʵʱƵ->
    //ϵͳƵΪ24MHz,
    //TMRA4MD1_TCK = 0x00;				    // ʱTMRA41Դʱѡ,A 2^11 (24M/2048=11.718kHz)λʱԼΪ0.0853ms
    TMRA4MD1_TCK = 0x01;                	// ʱTMRA41Դʱѡ,A 2^10 (24M/1024=23.437kHz)λʱԼΪ0.0426ms (42.6667us)

	//3.)---ܽųʼ->
	//---Ѷ֮ܽ趨(P0.3)TA4G->
    //P0CFGCR֮[bit7]=1(д)[bit6:4]=(λ)[bit3:0]Datasheet֮PNIC½ڲ趨 λ
	P0CFGCR = 0xB4;  						// P0.3OTA4G	1 011 0100

	//4.)---ģʽѶشѡ->
	TMRA4CR1_EDGE = 0x00;					// ص½ (H Pluse)
	//TMRA4CR1_EDGE = 0x01;					// ½ص (L Pluse)
	//TMRA4CR1_EDGE = 0x02;					// ص ()
	//TMRA4CR1_EDGE = 0x03;					// ½ص½ ()
	//TMRA4CR1_EDGE = 0x04;					// H Pluse

}



//*********************************************************************
// 	: TMRA4_16bit_PulseMeasure_Init()
// 	: TMRA4_16bit_ģʽʼ
// ע		: 16 λģʽ£TMRA40ص趨ʧЧֻʣTMRA41趨Ч
//            ֻTMRA41
//*********************************************************************
void TMRA4_16bit_PulseMeasure_Init(){
//====== ܿ( Enable) ======
	PCKEN0_TMRA4 = 1;                   	// TMRA4ܿ( Enable)  *ȿݴò	

//====== 趨 ======

	//1.)---ģʽ趨->
	TMRA4CFG_TCFG = set_16bit;				// TMRA4Ϊ16λģʽ
	TMRA4MD1_TCM  = pulse_measure;    		// TMRA41趨Ϊģʽ

    // /ֹ˫
	TMRA4MD1_DBE  = 1;                	    // 1: ʹ˫
    //TMRA4MD1_DBE  = 0;                    // 0: ֹ˫

	//2.)---趨ԴʵʱƵ->				// ϵͳƵΪ24MHz
    TMRA4MD1_TCK = 0x00;				    // ʱTMRA41Դʱѡ,A 2^11 (24M/2048=11.718kHz)λʱԼΪ0.0853ms
    //TMRA4MD1_TCK = 0x01;                	// ʱTMRA41Դʱѡ,A 2^10 (24M/1024=23.437kHz)λʱԼΪ0.0426ms (42.6667us)


	//3.)---ܽųʼ->
	//---Ѷ֮ܽ趨(P0.3)TA4G->
    //P0CFGCR֮[bit7]=1(д)[bit6:4]=(λ)[bit3:0]Datasheet֮PNIC½ڲ趨 λ
	P0CFGCR = 0xB4;  						// P0.3OTA4G	1 011 0100

	//4.)---ģʽѶشѡ->
	TMRA4CR1_EDGE = 0x00;					// ص½ (H Pluse)
	//TMRA4CR1_EDGE = 0x01;					// ½ص (L Pluse)
	//TMRA4CR1_EDGE = 0x02;					// ص ()
	//TMRA4CR1_EDGE = 0x03;					// ½ص½ ()
	//TMRA4CR1_EDGE = 0x04;					// H Pluse

}



//*********************************************************************
// 	: TMRA40_IntEnable()
// 	: TMRA40ж (Enable)
// ע		:  8λģʽ£TMRA40ʹ
//*********************************************************************
void TMRA40_IntEnable(){
	__ASM("DI");					    	// ֹпж
	IER_TMRA40_IRQ = 1;                 	// TMRA40 ж
	
	//---жϿ->
	TMRA4CR0_EDGEIE = 1;					// ж
	
	//---λжϿ->
	//TMRA4CR0_TMROVIE = 1;             	// λʱTMRA40жҪ
	
	__ASM("EI");							// пж
}


//*********************************************************************
// 	: TMRA41_IntEnable()
// 	: TMRA41ж (Enable)
// ע		: 1.  8λģʽ£TMRA41ʹ
//            2. 16λģʽ£TMRA40ص趨ʧЧֻʣTMRA41趨Ч
//               ֻTMRA41ж
//*********************************************************************
void TMRA41_IntEnable(){
	__ASM("DI");					    	// ֹпж
	IER_TMRA41_IRQ = 1;                 	// TMRA41 ж
	
	//---жϿ->
	TMRA4CR1_EDGEIE = 1;					// ж
	
	//---λжϿ->
	//TMRA4CR1_TMROVIE = 1;             	// λʱTMRA41жҪ
	
	__ASM("EI");							// пж
}



//*********************************************************************
// 	: TMRA40_IntDisable()
// 	: TMRA40жϽֹ (Disable)
// ע		: 
//*********************************************************************
void TMRA40_IntDisable(){
	__ASM("DI");					    	// ֹпж
	IER_TMRA40_IRQ = 0;                 	// TMRA40 жϽֹ
	
	//---жϿ->
	//TMRA4CR0_EDGEIE = 0;					// ֹж
	
	//---λжϿ->
	//TMRA4CR0_TMROVIE = 0;             	// λʱTMRA40жҪ
	
	__ASM("EI");							// пж
}


//*********************************************************************
// 	: TMRA41_IntDisable()
// 	: TMRA41жϽֹ (Disable)
// ע		: 
//*********************************************************************
void TMRA41_IntDisable(){
	__ASM("DI");					    	// ֹпж
	IER_TMRA41_IRQ = 0;                 	// TMRA41 жϽֹ
	
	//---жϿ->
	//TMRA4CR1_EDGEIE = 0;					// ֹж
	
	//---λжϿ->
	//TMRA4CR1_TMROVIE = 0;             	// λʱTMRA41жҪ
	
	__ASM("EI");							// пж
}



//*********************************************************************
// 	: TMRA40_Start()
// 	: ʱTMRA40
// ע		:  8λģʽ£TMRA40ʹ
//*********************************************************************
void TMRA40_Start(){
	TMRA4CR0_RUN = 1;                   	// TMRA40ʼ
	
}


//*********************************************************************
// 	: TMRA41_Start()
// 	: ʱTMRA41
// ע		:  8λģʽ£TMRA41ʹ
//*********************************************************************
void TMRA41_Start(){
	TMRA4CR1_RUN = 1;                   	// TMRA41ʼ
	
}


//*********************************************************************
// 	: TMRA4_16bit_Start()
// 	: 16λʱTMRA40+TMRA41
// ע		: 
//*********************************************************************
void TMRA4_16bit_Start(){
	TMRA4CR1_RUN = 1;                   	// 16λʱ
	
}


//*********************************************************************
// 	: TMRA40_Stop()
// 	: ֹͣʱTMRA40
// ע		:  8λģʽ£TMRA40ʹ
//*********************************************************************
void TMRA40_Stop(){
	TMRA4CR0_RUN = 0;                   	// TMRA40ֹͣʱ
	IFR_TMRA40_IRQ = 0;						// TMRA40_IRQжϱ
}


//*********************************************************************
// 	: TMRA41_Stop()
// 	: ֹͣʱTMRA41
// ע		:  8λģʽ£TMRA41ʹ
//*********************************************************************
void TMRA41_Stop(){
	TMRA4CR1_RUN = 0;                   	// TMRA41ֹͣʱ
	IFR_TMRA41_IRQ = 0;						// TMRA41_IRQжϱ



}


//*********************************************************************
// 	: TMRA4_16bit_Stop()
// 	: ֹͣ16λʱTMRA40+TMRA41
// ע		: 
//*********************************************************************
void TMRA4_16bit_Stop(){
	TMRA4CR1_RUN = 0;                   	// ֹͣ16λʱ
	IFR_TMRA41_IRQ = 0;						// TMRA41_IRQжϱ
}


//*********************************************************************
// 	: TMRA4_16bit_Read_Measure_Period()
// 	: ȡڼֵ 
// ע		: *ڲģʽ
//*********************************************************************
unsigned int TMRA4_16bit_Read_Measure_Period(){
	Data_L = TMRA4DR0;						// ȶȡλԪ(L-Byte,8bit)
	Data_H = TMRA4DR1;						// ȶȡλԪ(H-Byte,8bit)
	
	measure_count = ((Data_H<<8) | Data_L); // ֮ϸߵλԪΪ16bit
	
}


//*********************************************************************
// 	: TMRA4_16bit_Read_Measure_Pulse_Width()
// 	: ȡֵ 
// ע		: *ģʽ
//*********************************************************************
unsigned int TMRA4_16bit_Read_Measure_Pulse_Width(){
	Data_PWL = TMRA4PWM0;					// ȶȡλԪ(L-Byte,8bit)
	Data_PWH = TMRA4PWM1;					// ȶȡλԪ(H-Byte,8bit)
	
	H_pulse_measure_count = ((Data_PWH<<8) | Data_PWL); // ֮ϸߵλԪΪ16bit
	
}



//*********************************************************************
// 	: __interrupt TMRA40_IRQ()
// 	: TMRA40жӳ
// ע		:  8λģʽ£TMRA40ʹ
//*********************************************************************
void __interrupt TMRA40_IRQ(void){
	__asm("NOP");							// ָ

	
}


//*********************************************************************
// 	: __interrupt TMRA41_IRQ()
// 	: TMRA41жӳ
// ע		: 1.  8λģʽ£TMRA41ʹ
//            2. 16λģʽ£ʹTMRA41жӳ
//*********************************************************************
void __interrupt TMRA41_IRQ(void){
	__asm("NOP");							// ָ
	
	if(TMRA4SR_EDGEI1){
		TMRA41_Int_Flag = 1;				// TMRA41жϷ趨Ϊ1
		
		TMRA4_16bit_Read_Measure_Pulse_Width();// ȡTMRA4ץȡļֵ
		//TMRA4_16bit_Read_Measure_Period();   // ȡTMRA4ץȡļֵ
		
		IFR_TMRA41_IRQ = 0;					// TMRA41_IRQжϱ
		
		
	}
	
}


