//*************************************************************************************
// 	: SQ7653_TMRA4_PulseMeasure.h
// 汾		: V1.0 2020/07/17A
// 		: TMRA4_PulseMeasure ͷļ 
// ע		:        
//**************************************************************************************
#ifndef _SQ7653_TMRA4_PULSEMEASURE_H__
#define _SQ7653_TMRA4_PULSEMEASURE_H__

/* ---------------------- extern ȫֱ ------------------------- */
extern unsigned char TMRA40_Int_Flag;	  	     // TMRA40жϷ
extern unsigned char TMRA41_Int_Flag;	  	     // TMRA41жϷ
extern unsigned int  measure_count;			 // ֮(for)
extern unsigned int  L_pulse_measure_count;   // ֮L_pulse(for)
extern unsigned int  H_pulse_measure_count;   // ֮H_pulse(for)
extern unsigned char Data_L  ,Data_H;			 // תȡTMRA4DRx 
extern unsigned char Data_PWL,Data_PWH;		 // תȡTMRA4PWMx

/* ---------------------- Զ ------------------------------ */
#define   enable    			  0x01		     // (Enable) 
#define   disable  				  0x00		     // ֹ(Disable)
//For t_mod_sel------
#define   set_8bit    			  0x00		     // 趨Ϊ 8λģʽ
//#define ppg_andlogic            0x01		 	 // 趨Ϊ ʱ01 PPG߼ANDģʽ 
#define   set_16bit  			  0x02		     // 趨Ϊ 16λģʽ
//#define pre_scale   			  0x04		     // 趨Ϊ ԤȷƵģʽ
//#define complementary   		  0x05		     // 趨Ϊ ģʽ


//For op_mod_sel------
//#define timer    				  0x00		     // 趨Ϊ ʱģʽ
//#define event  		          0x01		     // 趨Ϊ ¼ģʽ 
//#define capture  				  0x03	  	     // 趨Ϊ ģʽ
//#define pwm                     0x04		     // 趨Ϊ PWMģʽ
#define pulse_measure             0x05		     // 趨Ϊ ģʽ
//#define ppg					  0x06		     // 趨Ϊ ɳPPGģʽ

//----------------------------------------------------------------
void TMRA40_8bit_PulseMeasure_Init();     		 // TMRA40  8λʱʼ
void TMRA41_8bit_PulseMeasure_Init();     		 // TMRA41  8λʱʼ
void TMRA4_16bit_PulseMeasure_Init();			 // TMRA4  16λʱʼ

void TMRA40_IntEnable();					     // TMRA40 ж (Enable)
void TMRA41_IntEnable();					     // TMRA41 ж (Enable)

void TMRA40_IntDisable();					     // TMRA40 жϽֹ (Disable)
void TMRA41_IntDisable();					     // TMRA41 жϽֹ (Disable)

void TMRA40_Start();							 // ʱTMRA40
void TMRA41_Start();							 // ʱTMRA41
void TMRA4_16bit_Start();						 // 16λʱTMRA40+TMRA41

void TMRA40_Stop();							 	 // ֹͣʱTMRA40
void TMRA41_Stop();							 	 // ֹͣʱTMRA41
void TMRA4_16bit_Stop();						 // ֹͣ16λʱTMRA40+TMRA41

unsigned int TMRA4_16bit_Read_Measure_Period();	    // ȡڼֵ 
unsigned int TMRA4_16bit_Read_Measure_Pulse_Width();  // ȡֵ 

void __interrupt TMRA40_IRQ(void);			  	 // TMRA40жӳ
void __interrupt TMRA41_IRQ(void);			  	 // TMRA41жӳ


#endif


