//*************************************************************************************
// 	: SQ7653_TMRA0_Timer.c
// 汾		: V1.0 2020/07/17A
// 		: Timer A0 (TMRA0) Timerģʽʹú
// ע		: TMRA0_Timer غ㼯ڱӳ
//**************************************************************************************
#include "main.h"

unsigned char TMRA00_Int_Flag;		  	// TMRA00жϷ
unsigned char TMRA01_Int_Flag;		  	// TMRA01жϷ

//*********************************************************************
// 	: TMRA00_8bit_Timer_Init()
// 	: TMRA00 8λʱģʽʼ
// ע		: TMRA0֮Counter0 (TMRA00)
//*********************************************************************
void TMRA00_8bit_Timer_Init(){

//====== ܿ( Enable) ======
	PCKEN0_TMRA0 = 1;                   // TMRA0ܿ( Enable)  *ȿݴò

//====== 趨 ======

	//1.)---ģʽ趨->
	TMRA0CFG_TCFG = set_8bit;			// TMRA0Ϊ8λģʽ
	TMRA0MD0_TCM  = timer ;				// Counter0 (TMRA00)ģʽ趨Ϊʱģʽ
    
    // /ֹ˫
	TMRA0MD0_DBE  = 1;                	// 1: ʹ˫
    //TMRA0MD0_DBE  = 0;                // 0: ֹ˫
    	
	//2.)---趨ԴʱƵ->
	// ϵͳƵΪ24MHz,
	TMRA0MD0_TCK   = 0x00;			    // ʱTMRA00Դʱѡ,A 2^11 (24M/2048=11.718kHz)λʱԼΪ0.0853ms
	//TMRA0MD0_TCK = 0x01;				// ʱTMRA00Դʱѡ,A 2^10 (24M/1024=23.437kHz)λʱԼΪ0.0426ms
	
}



//*********************************************************************
// 	: TMRA01_8bit_Timer_Init()
// 	: TMRA01 8λʱģʽʼ
// ע		: TMRA0֮Counter1 (TMRA01)
//*********************************************************************
void TMRA01_8bit_Timer_Init(){

//====== ܿ( Enable) ======
	PCKEN0_TMRA0 = 1;                   // TMRA0ܿ( Enable)  *ȿݴò

//====== 趨 ======

	//1.)---ģʽ趨->
	TMRA0CFG_TCFG = set_8bit;			// TMRA0Ϊ8λģʽ
	TMRA0MD1_TCM  = timer ;				// Counter1 (TMRA01)ģʽ趨Ϊʱģʽ
    
    // /ֹ˫
	TMRA0MD1_DBE  = 1;                	// 1: ʹ˫
    //TMRA0MD1_DBE  = 0;                // 0: ֹ˫

	//2.)---趨ԴʱƵ->
	// ϵͳƵΪ24MHz,
	TMRA0MD1_TCK  = 0x00;			    // ʱTMRA01Դʱѡ,A 2^11 (24M/2048=11.718kHz)λʱԼΪ0.0853ms
    //TMRA0MD1_TCK = 0x01;				// ʱTMRA01Դʱѡ,A 2^10 (24M/1024=23.437kHz)λʱԼΪ0.0426ms	
	
}



//*********************************************************************
// 	: TMRA0_16bit_Timer_Init()
// 	: TMRA0 16λʱģʽʼ
// ע		: 16 λģʽ£TMRA00ص趨ʧЧֻʣTMRA01趨Ч
//            ֻTMRA01
//*********************************************************************
void TMRA0_16bit_Timer_Init(){

//====== ܿ( Enable) ======
	PCKEN0_TMRA0 = 1;                   // TMRA0ܿ( Enable)  *ȿݴò

//====== 趨 ======
	//1.)---ģʽ趨->
	TMRA0CFG_TCFG = set_16bit;			// TMRA0Ϊ16λģʽ
	TMRA0MD1_TCM  = timer ;				// Counter1 (TMRA01)ģʽ趨Ϊʱģʽ
	
    // /ֹ˫
	TMRA0MD1_DBE  = 1;                	// 1: ʹ˫
    //TMRA0MD1_DBE  = 0;                // 0: ֹ˫

	//2.)---趨Դʱ->				
	//ϵͳƵΪ24MHz,
    TMRA0MD1_TCK     = 0x00;		    // ʱTMRA01Դʱѡ,A 2^11 (24M/2048=11.718kHz)λʱԼΪ0.0853ms
	//TMRA0MD1_TCK   = 0x01;			// ʱTMRA01Դʱѡ,A 2^10 (24M/1024=23.437kHz)λʱԼΪ0.0426ms

}


//*********************************************************************
// 	: TMRA00_IntEnable()
// 	: TMRA00ж (Enable)
// ע		:  8λģʽ£TMRA00ʹ
//*********************************************************************
void TMRA00_IntEnable(){
	__ASM("DI");					    // ֹпж
	IER_TMRA00_IRQ = 1;                 // TMRA00 ж
	
	TMRA0CR0_TMROVIE = 0;               // λжϿ,λʱTMRA00жҪ
	//TMRA0CR0_TMROVIE = 1;             // λжϿ,λʱTMRA00жҪ
	
	__ASM("EI");						// пж
}


//*********************************************************************
// 	: TMRA01_IntEnable()
// 	: TMRA01ж (Enable)
// ע		: 1.  8λģʽ£TMRA01ʹ
//            2. 16λģʽ£TMRA00ص趨ʧЧֻʣTMRA01趨Ч
//               ֻTMRA01ж
//*********************************************************************
void TMRA01_IntEnable(){
	__ASM("DI");					    // ֹпж
	IER_TMRA01_IRQ = 1;                 // TMRA01 ж
	
	TMRA0CR1_TMROVIE = 0;               // λжϿ,λʱTMRA01жҪ
	//TMRA0CR1_TMROVIE = 1;             // λжϿ,λʱTMRA01жҪ
	
	__ASM("EI");						// пж
}



//*********************************************************************
// 	: TMRA00_IntDisable()
// 	: TMRA00жϽֹ (Disable)
// ע		: 
//*********************************************************************
void TMRA00_IntDisable(){
	__ASM("DI");					    // ֹпж
	IER_TMRA00_IRQ = 0;                 // TMRA00 жϽֹ
	__ASM("EI");						// пж
	
}


//*********************************************************************
// 	: TMRA01_IntDisable()
// 	: TMRA01жϽֹ (Disable)
// ע		: 
//*********************************************************************
void TMRA01_IntDisable(){
	__ASM("DI");					    // ֹпж
	IER_TMRA31_IRQ = 0;                 // TMRA01 жϽֹ
	__ASM("EI");						// пж
	
}



//*********************************************************************
// 	: TMRA00_SetPeriod()
// 	: ʱTMRA00 趨
// ע		: Timer A0,Counter0
//*********************************************************************
void TMRA00_SetPeriod(unsigned int period){	
	TMRA0DR0 = period;              	// 趨TMRA00

}


//*********************************************************************
// 	: TMRA01_SetPeriod()
// 	: ʱTMRA01 趨
// ע		: Timer A0,Counter1
//*********************************************************************
void TMRA01_SetPeriod(unsigned int period){	
	TMRA0DR1 = period;              	// 趨TMRA01

}


//*********************************************************************
//    : TMRA0_16bit_SetPeriod()
//  : 16λʱTMRA00+TMRA01 趨
// ע     : Timer A0,Counter0 + Counter1
//*********************************************************************
void TMRA0_16bit_SetPeriod(unsigned int period){    
    TMRA0DR0 = period & 0x00ff;         // 趨λ
    TMRA0DR1 = period>>8;               // 趨λ
	
}


//*********************************************************************
// 	: TMRA00_Start()
// 	: ʱTMRA00
// ע		:  8λģʽ£TMRA00ʹ
//*********************************************************************
void TMRA00_Start(){
	TMRA0CR0_RUN = 1;                   // TMRA00ʼ
	
}


//*********************************************************************
// 	: TMRA01_Start()
// 	: ʱTMRA01
// ע		:  8λģʽ£TMRA01ʹ
//*********************************************************************
void TMRA01_Start(){
	TMRA0CR1_RUN = 1;                   // TMRA01ʼ
	
}


//*********************************************************************
// 	: TMRA0_16bit_Start()
// 	: 16λʱTMRA00+TMRA01
// ע		: 
//*********************************************************************
void TMRA0_16bit_Start(){
	TMRA0CR1_RUN = 1;                   // 16λʱ
	
}


//*********************************************************************
// 	: TMRA00_Stop()
// 	: ֹͣʱTMRA00
// ע		:  8λģʽ£TMRA00ʹ
//*********************************************************************
void TMRA00_Stop(){
	TMRA0CR0_RUN = 0;                   // TMRA00ֹͣʱ

}


//*********************************************************************
// 	: TMRA01_Stop()
// 	: ֹͣʱTMRA01
// ע		:  8λģʽ£TMRA01ʹ
//*********************************************************************
void TMRA01_Stop(){
	TMRA0CR1_RUN = 0;                   // TMRA01ֹͣʱ

}


//*********************************************************************
// 	: TMRA0_16bit_Stop()
// 	: ֹͣ16λʱTMRA00+TMRA01
// ע		: 
//*********************************************************************
void TMRA0_16bit_Stop(){
	TMRA0CR1_RUN = 0;                   // ֹͣ16λʱ
	
}


//*********************************************************************
// 	: __interrupt TMRA00_IRQ()
// 	: TMRA00жӳ
// ע		:  8λģʽ£TMRA00ʹ
//*********************************************************************
void __interrupt TMRA00_IRQ(void){
	__asm("NOP");						// ָ
	TMRA00_Int_Flag = 1;				// TMRA00жϷ趨Ϊ1
	
	
}


//*********************************************************************
// 	: __interrupt TMRA01_IRQ()
// 	: TMRA01жӳ
// ע		: 1.  8λģʽ£TMRA01ʹ
//            2. 16λģʽ£ʹTMRA01жӳ
//*********************************************************************
void __interrupt TMRA01_IRQ(void){
	__asm("NOP");						// ָ
	TMRA01_Int_Flag = 1;				// TMRA01жϷ趨Ϊ1
	
	
}

